/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2012, 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_sau.c
* Version      : Code Generator for RL78/G10 V1.04.02.01 [15 May 2015]
* Device(s)    : R5F10Y46
* Tool-Chain   : CCRL
* Description  : This file implements device driver for SAU module.
* Creation Date: 2015/09/11
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_sau.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_SAU0_Create
* Description  : This function initializes the SAU0 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_SAU0_Create(void)
{
    SAU0EN = 1U;    /* supply SAU0 clock */
    NOP();
    NOP();
    NOP();
    NOP();
    SPS0 = _00_SAU_CK00_FCLK_0 | _00_SAU_CK01_FCLK_0;
    R_IIC00_Create();
}
/***********************************************************************************************************************
* Function Name: R_IIC00_Create
* Description  : This function initializes the IIC00 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_IIC00_Create(void)
{
    ST0 |= _01_SAU_CH0_STOP_TRG_ON;    /* disable IIC00 */
    IICMK00 = 1U;    /* disable INTIIC00 interrupt */
    IICIF00 = 0U;    /* clear INTIIC00 interrupt flag */
    /* Set INTIIC00 low priority */
    IICPR100 = 1U;
    IICPR000 = 1U;
    SIR00 = _02_SAU_SIRMN_PECTMN | _01_SAU_SIRMN_OVCTMN;    /* clear error flag */
    SMR00L = _20_SAU_SMRMN_INITIALVALUE | _00_SAU_EDGE_FALL | _04_SAU_MODE_IIC | _00_SAU_TRANSFER_END;
    SMR00H = _00_SAU_CLOCK_SELECT_CK00 | _00_SAU_CLOCK_MODE_CKS | _00_SAU_TRIGGER_SOFTWARE;
    SCR00L = _00_SAU_MSB | _10_SAU_STOP_1 | _07_SAU_LENGTH_8;
    SCR00H = _00_SAU_TIMING_1 | _00_SAU_INTSRE_MASK | _00_SAU_PARITY_NONE;
    SDR00H = _EA_IIC00_DIVISOR;
    SO0 |= _01_SAU_CH0_DATA_OUTPUT_1;
    CKO0 |= _01_SAU_CH0_CLOCK_OUTPUT_1;
    /* Set SCL00, SDA00 pin */
    POM0 |= 0x02U;
    PMC0 &= 0xF9U;
    P0 |= 0x06U;
    PM0 &= 0xF9U;
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
