
/***********************************************************************************************************************
* File Name    : r_IIC_LIB.h
* Version      : 1.01
* program      : `R
* Device(s)    : R5F10Y46
* Tool-Chain   : CCRL
* Description  : This file implements device driver for Serial module.
* Creation Date: 2015/09/14
* Modified Date: 2015/10/06
***********************************************************************************************************************/

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
MD_STATUS R_IIC_Master_Send(uint8_t adr, uint8_t * const tx_buf, uint16_t tx_num);
                                        /* transmit data to slave       */
MD_STATUS R_IIC_Master_Receive(uint8_t adr, uint8_t * const rx_buf, uint16_t rx_num);
                                        /* recieve data from slave      */
MD_STATUS R_IIC_wait_comend(void);      /* wait for transfer end        */
MD_STATUS R_IIC_check_comstate(void);   /* check transfer status        */
/*  00 : operation end witout error
    01 : transmit data operation mode
    41 : receive data operation mode
    81 : slave address transmit for receive mode
    FF : operation error
*/

MD_STATUS R_IIC_StopCondition(void);    /* issue STOP condition         */

void IIC_TM01_init(void);               /* change Timer01 mode & start  */
void wait_time(uint8_t time);           /* wait for 20us * arguments    */
void wait_20us(void);                   /* wait 20us using TM03         */

/***********************************************************************************************************************
Global variable
***********************************************************************************************************************/
//extern  uint8_t   g_iic00_status;       /* iic00 master operationflag   */
/*  00 : operation end witout error
    01 : transmit data operation mode
    41 : receive data operation mode
    81 : slave address transmit for receive mode
    FF : operation error
*/

